package com.gic.cloud.web.controller;

import com.gic.cloud.dto.AccountGroupDTO;
import com.gic.cloud.service.AccountGroupApiService;
import com.gic.cloud.service.UserApiService;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/user")
public class UserController {
    private final static Logger LOGGER = LogManager.getLogger(UserController.class);

    @Autowired
    private AccountGroupApiService accountGroupApiService;
    @Autowired
    private UserApiService userApiService;

    @RequestMapping("/save-account-group")
    public RestResponse saveAccountGroup(AccountGroupDTO dto) {
        return ResultControllerUtils.commonResult(accountGroupApiService.saveAccountGroup(dto));
    }

    @RequestMapping("/edit-account-group")
    public RestResponse editAccountGroup(AccountGroupDTO dto) {
        return ResultControllerUtils.commonResult(accountGroupApiService.editAccountGroup(dto));
    }

    @RequestMapping("/sort-account-group")
    public RestResponse sortAccountGroup(Integer accountGroupId, Integer targetSort) {
        return ResultControllerUtils.commonResult(accountGroupApiService.sortAccountGroup(accountGroupId, targetSort));
    }

    @RequestMapping("/list-account-group")
    public RestResponse listAccountGroup() {
        return ResultControllerUtils.commonResult(accountGroupApiService
                .listAccountGroupOfCountMember(UserDetailUtils.getUserDetail().getEnterpriseId()));
    }

    @RequestMapping("/delete-account-group")
    public RestResponse deleteAccountGroup(Integer accountGroupId) {
        return ResultControllerUtils.commonResult(accountGroupApiService.deleteAccountGroup(accountGroupId));
    }
}
